const { createServer } = require("http")
let pages = ["/"]
const path = require("path")
const term = require("terminal-kit").terminal
const express = require('express');
const app = express()
const fs = require('fs');
let mainpage = null
var url = require('url');
let port = 8000
app.set('json spaces', 2);
const server = createServer((req, res, ) => {
    res.writeHead(200, { 'Content-Type': 'text/html' })
    if (mainpage == null) {
        res.write("<!DOCTYPE html><html><head><title>Under in Progress! 🔨</title><meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\"><style>* {margin: 0;    padding: 0;    font-family: 'Poppins', sans-serif;    box-sizing: border-box;}.header {    height: 80px;    width: 100%;    padding: 0 8%;    background-color: #f0f0f0;    position: relative;}nav {    display: flex;    align-items: center;    justify-content: space-between;}.logo {    width: 50px;}.nav-links {    padding: 28px 0;}.nav-links li {    display: inline-block;    margin: 0 15px;}.nav-links li a {    color: #000;    text-decoration: none;    color: 000;    padding: 5px 0;    position: relative;}.nav-links li a::after {    color: #000;    content: '';    background: #606060;    width: 0%;    height: 2px;    position: absolute;    bottom: 0;    left: 0;    transition: width 0.5s;}.nav-links li a:hover::after {    color: #000;    width: 100%;}.i {    margin-right: 600px;}</style></head><body><div class=\"header\"><nav><img src=\"https://cdn.discordapp.com/attachments/706455502321746012/1036125495550558258/hammer.png\" alt=\"Hammer...\" class=\"logo\"><h1 class=\"i\">Under Progress! 🔨</h1><ul class=\"nav-links\"><li><a href=\"/\">Home</a></li><li><a href=\"https://npmjs.com/lazyhttp\">Lazyhttp</a></li></ul></nav></div><div class=\"content\"><h1 style=\"text-align: center; padding-top:80px\">This Site Waiting For Code... 🧱</h1></div></body></html>")
    } else {
        fs.readFile(mainpage, 'utf8', (err, data) => {
            if (err) {
                console.error(err);
                return;
            }
            res.write(`${data}`)
            res.setDefaultEncoding("utf8")
        });
    }
    return res.end();
})

app.get('headers', (req, res) => {
    res.status(200).json(req.headers)
})

function createPage(Path, FileToSend) {
    app.get(Path, (req, res) => {
        res.sendFile(path.join(__dirname, FileToSend))
        term.magenta(Path + "'s Headers 💾 : \n").red(req.headers)
        pages.push(Path)
    })
}


server.listen(port, () => {
    term.bold.blue("Loaded!  ✨ ").red(" | ").green("Succesfully Server is Started on ").magenta("https://localhost:" + port)
})

module.exports = {
    port: port,
    mainPage: mainpage,
    createPage: createPage()
}